
;CodeVisionAVR C Compiler V1.24.8d Professional
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Test1.vec"
	.INCLUDE "Test1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.8d Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : 
;       9 Version : 
;      10 Date    : 2007/09/09
;      11 Author  : F4CG                            
;      12 Company : F4CG                            
;      13 Comments: 
;      14 
;      15 
;      16 Chip type           : ATmega16
;      17 Program type        : Application
;      18 Clock frequency     : 16.000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega16.h>
;      25 #include <stdlib.h>
;      26 #include <delay.h>
;      27 
;      28 #define keypad_DDR DDRB
;      29 #define keypad_PORT PORTB
;      30 #define keypad_PIN PINB
;      31 #define key_ctr 5
;      32 #define key_delay 1
;      33 
;      34 
;      35 unsigned char const source[5][256] = {

	.CSEG
;      36 {
;      37 128 , 129 , 129 , 130 , 131 , 131 , 132 , 133 , 133 , 134 , 134 , 135 , 136 , 136 , 137 , 137 , 
;      38 138 , 139 , 139 , 140 , 140 , 141 , 141 , 142 , 142 , 143 , 143 , 144 , 144 , 145 , 145 , 146 , 
;      39 146 , 146 , 147 , 147 , 148 , 148 , 148 , 149 , 149 , 149 , 150 , 150 , 150 , 151 , 151 , 151 , 
;      40 151 , 152 , 152 , 152 , 152 , 152 , 152 , 153 , 153 , 153 , 153 , 153 , 153 , 153 , 153 , 153 , 
;      41 153 , 153 , 153 , 153 , 153 , 153 , 153 , 153 , 152 , 152 , 152 , 152 , 152 , 152 , 151 , 151 , 
;      42 151 , 151 , 150 , 150 , 150 , 149 , 149 , 149 , 148 , 148 , 148 , 147 , 147 , 146 , 146 , 146 , 
;      43 145 , 145 , 144 , 144 , 143 , 143 , 142 , 142 , 141 , 141 , 140 , 140 , 139 , 139 , 138 , 137 , 
;      44 137 , 136 , 136 , 135 , 134 , 134 , 133 , 133 , 132 , 131 , 131 , 130 , 129 , 129 , 128 , 128 , 
;      45 127 , 126 , 126 , 125 , 124 , 124 , 123 , 123 , 122 , 121 , 121 , 120 , 120 , 119 , 118 , 118 , 
;      46 117 , 117 , 116 , 116 , 115 , 114 , 114 , 113 , 113 , 112 , 112 , 111 , 111 , 110 , 110 , 110 , 
;      47 109 , 109 , 108 , 108 , 107 , 107 , 107 , 106 , 106 , 106 , 105 , 105 , 105 , 105 , 104 , 104 , 
;      48 104 , 104 , 103 , 103 , 103 , 103 , 103 , 103 , 102 , 102 , 102 , 102 , 102 , 102 , 102 , 102 , 
;      49 102 , 102 , 102 , 102 , 102 , 102 , 102 , 103 , 103 , 103 , 103 , 103 , 103 , 104 , 104 , 104 , 
;      50 104 , 105 , 105 , 105 , 105 , 106 , 106 , 106 , 107 , 107 , 107 , 108 , 108 , 109 , 109 , 110 , 
;      51 110 , 110 , 111 , 111 , 112 , 112 , 113 , 113 , 114 , 114 , 115 , 116 , 116 , 117 , 117 , 118 , 
;      52 118 , 119 , 120 , 120 , 121 , 121 , 122 , 123 , 123 , 124 , 124 , 125 , 126 , 126 , 127 , 128 }, //-------%20-------
;      53 {
;      54 129 , 130 , 131 , 132 , 134 , 135 , 136 , 138 , 139 , 140 , 141 , 142 , 144 , 145 , 146 , 147 , 
;      55 148 , 150 , 150 , 152 , 153 , 154 , 155 , 156 , 157 , 158 , 159 , 160 , 161 , 162 , 163 , 164 , 
;      56 164 , 165 , 166 , 167 , 168 , 168 , 169 , 170 , 171 , 171 , 172 , 172 , 173 , 174 , 174 , 175 , 
;      57 175 , 176 , 176 , 176 , 177 , 177 , 177 , 178 , 178 , 178 , 178 , 178 , 178 , 178 , 178 , 178 , 
;      58 178 , 178 , 178 , 178 , 178 , 178 , 178 , 178 , 177 , 177 , 177 , 176 , 176 , 176 , 175 , 175 , 
;      59 174 , 174 , 173 , 172 , 172 , 171 , 171 , 170 , 169 , 168 , 168 , 167 , 166 , 165 , 164 , 164 , 
;      60 163 , 162 , 161 , 160 , 159 , 158 , 157 , 156 , 155 , 154 , 153 , 152 , 150 , 150 , 148 , 147 , 
;      61 146 , 145 , 144 , 142 , 141 , 140 , 139 , 138 , 136 , 135 , 134 , 132 , 131 , 130 , 129 , 128 , 
;      62 126 , 125 , 124 , 123 , 121 , 120 , 119 , 118 , 116 , 115 , 114 , 113 , 112 , 110 , 109 , 108 , 
;      63 107 , 106 , 105 , 104 , 102 , 101 , 100 , 99  , 98  , 97  , 96  , 95  , 94  , 93  , 92  , 92  , 
;      64 91  , 90  , 89  , 88  , 87  , 87  , 86  , 85  , 84  , 84  , 83  , 83  , 82  , 82  , 81  , 80  , 
;      65 80  , 80  , 79  , 79  , 78  , 78  , 78  , 78  , 77  , 77  , 77  , 77  , 77  , 77  , 77  , 77  , 
;      66 77  , 77  , 77  , 77  , 77  , 77  , 77  , 78  , 78  , 78  , 78  , 79  , 79  , 80  , 80  , 80  , 
;      67 81  , 82  , 82  , 83  , 83  , 84  , 84  , 85  , 86  , 87  , 87  , 88  , 89  , 90  , 91  , 92  , 
;      68 92  , 93  , 94  , 95  , 96  , 97  , 98  , 99  , 100 , 101 , 102 , 104 , 105 , 106 , 107 , 108 , 
;      69 109 , 110 , 112 , 113 , 114 , 115 , 116 , 118 , 119 , 120 , 121 , 123 , 124 , 125 , 126 , 128 }, //-------%40-------
;      70 {
;      71 130 , 131 , 133 , 135 , 137 , 139 , 141 , 143 , 144 , 146 , 148 , 150 , 152 , 154 , 155 , 157 , 
;      72 159 , 161 , 162 , 164 , 166 , 167 , 168 , 170 , 172 , 173 , 174 , 176 , 178 , 179 , 180 , 182 , 
;      73 183 , 184 , 186 , 187 , 188 , 189 , 190 , 191 , 192 , 193 , 194 , 195 , 196 , 197 , 198 , 198 , 
;      74 199 , 200 , 200 , 201 , 202 , 202 , 202 , 203 , 203 , 203 , 204 , 204 , 204 , 204 , 204 , 204 , 
;      75 204 , 204 , 204 , 204 , 204 , 203 , 203 , 203 , 202 , 202 , 202 , 201 , 200 , 200 , 199 , 198 , 
;      76 198 , 197 , 196 , 195 , 194 , 193 , 192 , 191 , 190 , 189 , 188 , 187 , 186 , 184 , 183 , 182 , 
;      77 180 , 179 , 178 , 176 , 174 , 173 , 172 , 170 , 168 , 167 , 166 , 164 , 162 , 161 , 159 , 157 , 
;      78 155 , 154 , 152 , 150 , 148 , 146 , 144 , 143 , 141 , 139 , 137 , 135 , 133 , 131 , 130 , 128 , 
;      79 126 , 124 , 122 , 121 , 118 , 116 , 114 , 113 , 111 , 109 , 107 , 106 , 104 , 102 , 100 , 98  , 
;      80 96  , 95  , 94  , 92  , 90  , 88  , 87  , 85  , 84  , 82  , 81  , 79  , 78  , 76  , 75  , 74  , 
;      81 72  , 71  , 70  , 68  , 67  , 66  , 65  , 64  , 63  , 62  , 61  , 60  , 59  , 59  , 58  , 57  , 
;      82 56  , 56  , 55  , 54  , 54  , 53  , 53  , 53  , 52  , 52  , 52  , 52  , 52  , 52  , 52  , 52  , 
;      83 52  , 52  , 52  , 52  , 52  , 52  , 52  , 53  , 53  , 53  , 54  , 54  , 55  , 56  , 56  , 57  , 
;      84 58  , 59  , 59  , 60  , 61  , 62  , 63  , 64  , 65  , 66  , 67  , 68  , 70  , 71  , 72  , 74  , 
;      85 75  , 76  , 78  , 79  , 81  , 82  , 84  , 85  , 87  , 88  , 90  , 92  , 94  , 95  , 96  , 98  , 
;      86 100 , 102 , 104 , 106 , 107 , 109 , 111 , 113 , 114 , 116 , 118 , 121 , 122 , 124 , 126 , 128 }, //-------%60-------
;      87 {
;      88 130 , 133 , 135 , 138 , 141 , 143 , 146 , 148 , 150 , 153 , 155 , 158 , 160 , 162 , 165 , 167 , 
;      89 170 , 172 , 174 , 176 , 178 , 181 , 182 , 185 , 186 , 189 , 190 , 193 , 194 , 197 , 198 , 200 , 
;      90 202 , 203 , 206 , 207 , 209 , 210 , 211 , 213 , 214 , 215 , 217 , 218 , 219 , 220 , 222 , 222 , 
;      91 223 , 224 , 225 , 226 , 226 , 227 , 227 , 228 , 229 , 229 , 230 , 230 , 230 , 230 , 230 , 230 , 
;      92 230 , 230 , 230 , 230 , 230 , 229 , 229 , 228 , 227 , 227 , 226 , 226 , 225 , 224 , 223 , 222 , 
;      93 222 , 220 , 219 , 218 , 217 , 215 , 214 , 213 , 211 , 210 , 209 , 207 , 206 , 203 , 202 , 200 , 
;      94 198 , 197 , 194 , 193 , 190 , 189 , 186 , 185 , 182 , 181 , 178 , 176 , 174 , 172 , 170 , 167 , 
;      95 165 , 162 , 160 , 158 , 155 , 153 , 150 , 148 , 146 , 143 , 141 , 138 , 135 , 133 , 130 , 128 , 
;      96 126 , 123 , 121 , 118 , 115 , 113 , 110 , 108 , 106 , 103 , 101 , 98  , 96  , 94  , 91  , 89  , 
;      97 86  , 84  , 82  , 80  , 78  , 75  , 74  , 71  , 70  , 67  , 66  , 63  , 62  , 59  , 58  , 56  , 
;      98 54  , 53  , 50  , 49  , 47  , 46  , 45  , 43  , 42  , 41  , 39  , 38  , 37  , 36  , 34  , 34  , 
;      99 33  , 32  , 31  , 30  , 30  , 29  , 29  , 28  , 27  , 27  , 26  , 26  , 26  , 26  , 26  , 26  , 
;     100 26  , 26  , 26  , 26  , 26  , 27  , 27  , 28  , 29  , 29  , 30  , 30  , 31  , 32  , 33  , 34  , 
;     101 34  , 36  , 37  , 38  , 39  , 41  , 42  , 43  , 45  , 46  , 47  , 49  , 50  , 53  , 54  , 56  , 
;     102 58  , 59  , 62  , 63  , 66  , 67  , 70  , 71  , 74  , 75  , 78  , 80  , 82  , 84  , 86  , 89  , 
;     103 91  , 94  , 96  , 98  , 101 , 103 , 106 , 108 , 110 , 113 , 115 , 118 , 121 , 123 , 126 , 128 }, //-------%80-------
;     104 {
;     105 131 , 134 , 137 , 140 , 144 , 147 , 150 , 153 , 156 , 159 , 162 , 165 , 168 , 171 , 174 , 177 ,
;     106 180 , 183 , 185 , 188 , 191 , 194 , 196 , 199 , 201 , 204 , 206 , 209 , 211 , 214 , 216 , 218 ,
;     107 220 , 222 , 225 , 227 , 229 , 230 , 232 , 234 , 236 , 237 , 239 , 240 , 242 , 243 , 245 , 246 ,
;     108 247 , 248 , 249 , 250 , 251 , 252 , 252 , 253 , 254 , 254 , 255 , 255 , 255 , 255 , 255 , 255 ,
;     109 255 , 255 , 255 , 255 , 255 , 254 , 254 , 253 , 252 , 252 , 251 , 250 , 249 , 248 , 247 , 246 ,
;     110 245 , 243 , 242 , 240 , 239 , 237 , 236 , 234 , 232 , 230 , 229 , 227 , 225 , 222 , 220 , 218 ,
;     111 216 , 214 , 211 , 209 , 206 , 204 , 201 , 199 , 196 , 194 , 191 , 188 , 185 , 183 , 180 , 177 ,
;     112 174 , 171 , 168 , 165 , 162 , 159 , 156 , 153 , 150 , 147 , 144 , 140 , 137 , 134 , 131 , 128 ,
;     113 125 , 122 , 119 , 116 , 112 , 109 , 106 , 103 , 100 , 97  , 94  , 91  , 88  , 85  , 82  , 79  ,
;     114 76  , 73  , 71  , 68  , 65  , 62  , 60  , 57  , 55  , 52  , 50  , 47  , 45  , 42  , 40  , 38  ,
;     115 36  , 34  , 31  , 29  , 27  , 26  , 24  , 22  , 20  , 19  , 17  , 16  , 14  , 13  , 11  , 10  ,
;     116 9   , 8   , 7   , 6   , 5   , 4   , 4   , 3   , 2   , 2   , 1   , 1   , 1   , 1   , 1   , 1   ,
;     117 1   , 1   , 1   , 1   , 1   , 2   , 2   , 3   , 4   , 4   , 5   , 6   , 7   , 8   , 9   , 10  ,
;     118 11  , 13  , 14  , 16  , 17  , 19  , 20  , 22  , 24  , 26  , 27  , 29  , 31  , 34  , 36  , 38  ,
;     119 40  , 42  , 45  , 47  , 50  , 52  , 55  , 57  , 60  , 62  , 65  , 68  , 71  , 73  , 76  , 79  ,
;     120 82  , 85  , 88  , 91  , 94  , 97  , 100 , 103 , 106 , 109 , 112 , 116 , 119 , 122 , 125 , 128 }}; //------%100-------
;     121 
;     122 
;     123 #define D20  0
;     124 #define D40  1
;     125 #define D60  2
;     126 #define D80  3
;     127 #define D100 4
;     128 #define F1hz 125000
;     129 #define dac1 PORTA
;     130 #define dac2 PORTD
;     131 #define F1 14
;     132 #define F2 24
;     133 #define F3 34
;     134 #define _FF_ 0.71112
;     135 
;     136 unsigned char const table[4][4]={{0,1,2,3},{4,5,6,7},{8,9,10,11},{12,13,14,15}};
;     137 // Alphanumeric LCD Module functions
;     138 #asm
;     139    .equ __lcd_port=0x15 ;PORTC
   .equ __lcd_port=0x15 ;PORTC
;     140 #endasm
;     141 #include <lcd.h>
;     142 
;     143 // Declare your global variables here
;     144 unsigned char Psec = D100;  //perSec Damane Freq

	.DSEG
;     145 unsigned char ph1 = 0;      //zavie phase 1
;     146 unsigned char ph2 = 0;      //zavie phase 2
;     147 unsigned long T1;           //Timer Numeric
_T1:
	.BYTE 0x4
;     148 unsigned int frequnce = 100;
;     149 unsigned int radu = 0;
;     150 unsigned char scale = 100;
;     151 // Timer 1 overflow interrupt service routine
;     152 
;     153 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     154 {

	.CSEG
_timer1_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     155 // Reinitialize Timer 1 value
;     156 TCNT1=T1;  
	CALL SUBOPT_0x0
;     157 dac1 = source[Psec][ph1];
	MOV  R31,R4
	LDI  R30,LOW(0)
	SUBI R30,LOW(-_source*2)
	SBCI R31,HIGH(-_source*2)
	MOVW R26,R30
	MOV  R30,R5
	CALL SUBOPT_0x1
	OUT  0x1B,R30
;     158 dac2 = source[Psec][ph2];
	MOV  R31,R4
	LDI  R30,LOW(0)
	SUBI R30,LOW(-_source*2)
	SBCI R31,HIGH(-_source*2)
	MOVW R26,R30
	MOV  R30,R6
	CALL SUBOPT_0x1
	OUT  0x12,R30
;     159 ph1+=2;
	INC  R5
	INC  R5
;     160 ph2+=2;
	INC  R6
	INC  R6
;     161 
;     162 //TCNT1L=0xAA;
;     163 // Place your code here
;     164 
;     165 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;     166 
;     167 // Declare your global variables here
;     168 //////////////////////////////////////////////
;     169 //////////////////////////////////////////////
;     170 
;     171 unsigned char scan_key(void)
;     172 {       
_scan_key:
;     173    unsigned char i=0,j=0,key_ctr_temp=0,key_temp=0,scan_code[4]={0xFE,0xFD,0xFB,0xF7};
;     174                              
;     175    for (i=0;i<4;i++)
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x6*2)
	LDI  R31,HIGH(_0x6*2)
	CALL __INITLOCB
	CALL __SAVELOCR4
;	i -> R16
;	j -> R17
;	key_ctr_temp -> R18
;	key_temp -> R19
;	scan_code -> Y+4
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	LDI  R16,LOW(0)
_0x8:
	CPI  R16,4
	BRLO PC+3
	JMP _0x9
;     176    {
;     177         keypad_PORT|=0x0F;
	IN   R30,0x18
	ORI  R30,LOW(0xF)
	OUT  0x18,R30
;     178         keypad_PORT&=scan_code[i];
	IN   R0,24
	MOV  R30,R16
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,4
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	AND  R30,R0
	OUT  0x18,R30
;     179         delay_ms(5);
	CALL SUBOPT_0x2
;     180         //key_temp=keypad_PIN;
;     181         if (keypad_PIN<0xF0)
	IN   R30,0x16
	CPI  R30,LOW(0xF0)
	BRLO PC+3
	JMP _0xA
;     182         {       
;     183            key_temp=keypad_PIN;
	IN   R19,22
;     184            for(j=0;j<key_ctr;j++)
	LDI  R17,LOW(0)
_0xC:
	CPI  R17,5
	BRSH _0xD
;     185            {
;     186               delay_ms(key_delay);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL SUBOPT_0x3
;     187               if(keypad_PIN==key_temp)
	IN   R30,0x16
	CP   R19,R30
	BRNE _0xE
;     188                  key_ctr_temp++; 
	SUBI R18,-1
;     189            }          
_0xE:
	SUBI R17,-1
	RJMP _0xC
_0xD:
;     190 //           if(key_ctr_temp==key_ctr)
;     191           {    key_ctr_temp = keypad_PIN;
	IN   R18,22
;     192                 switch(key_ctr_temp)
	MOV  R30,R18
;     193                 {
;     194                         case 238:
	CPI  R30,LOW(0xEE)
	BRNE _0x12
;     195                                 return 1;
	LDI  R30,LOW(1)
	RJMP _0x62
;     196                                 break;
;     197                         case 237:
_0x12:
	CPI  R30,LOW(0xED)
	BRNE _0x13
;     198                                 return 4;
	LDI  R30,LOW(4)
	RJMP _0x62
;     199                                 break;
;     200                         case 235:
_0x13:
	CPI  R30,LOW(0xEB)
	BRNE _0x14
;     201                                 return 7;
	LDI  R30,LOW(7)
	RJMP _0x62
;     202                                 break;     
;     203                         case 231:
_0x14:
	CPI  R30,LOW(0xE7)
	BRNE _0x15
;     204                                 return 41;
	LDI  R30,LOW(41)
	RJMP _0x62
;     205                                 break;
;     206                         case 222:
_0x15:
	CPI  R30,LOW(0xDE)
	BRNE _0x16
;     207                                 return 2;
	LDI  R30,LOW(2)
	RJMP _0x62
;     208                                 break;
;     209                         case 221:
_0x16:
	CPI  R30,LOW(0xDD)
	BRNE _0x17
;     210                                 return 5;
	LDI  R30,LOW(5)
	RJMP _0x62
;     211                                 break;     
;     212                         case 219:
_0x17:
	CPI  R30,LOW(0xDB)
	BRNE _0x18
;     213                                 return 8;
	LDI  R30,LOW(8)
	RJMP _0x62
;     214                                 break;
;     215                         case 215:
_0x18:
	CPI  R30,LOW(0xD7)
	BRNE _0x19
;     216                                 return 0;
	LDI  R30,LOW(0)
	RJMP _0x62
;     217                                 break;
;     218                         case 190:
_0x19:
	CPI  R30,LOW(0xBE)
	BRNE _0x1A
;     219                                 return 3;
	LDI  R30,LOW(3)
	RJMP _0x62
;     220                                 break;     
;     221                         case 189:
_0x1A:
	CPI  R30,LOW(0xBD)
	BRNE _0x1B
;     222                                 return 6;
	LDI  R30,LOW(6)
	RJMP _0x62
;     223                                 break;
;     224                         case 187:
_0x1B:
	CPI  R30,LOW(0xBB)
	BRNE _0x1C
;     225                                 return 9;
	LDI  R30,LOW(9)
	RJMP _0x62
;     226                                 break;
;     227                         case 183:
_0x1C:
	CPI  R30,LOW(0xB7)
	BRNE _0x1D
;     228                                 return 43;
	LDI  R30,LOW(43)
	RJMP _0x62
;     229                                 break;     
;     230                         case 126:
_0x1D:
	CPI  R30,LOW(0x7E)
	BRNE _0x1E
;     231                                 return 14;
	LDI  R30,LOW(14)
	RJMP _0x62
;     232                                 break;     
;     233                         case 125:
_0x1E:
	CPI  R30,LOW(0x7D)
	BRNE _0x1F
;     234                                 return 24;
	LDI  R30,LOW(24)
	RJMP _0x62
;     235                                 break;
;     236                         case 123:
_0x1F:
	CPI  R30,LOW(0x7B)
	BRNE _0x20
;     237                                 return 34;
	LDI  R30,LOW(34)
	RJMP _0x62
;     238                                 break;
;     239                         case 119:
_0x20:
	CPI  R30,LOW(0x77)
	BRNE _0x22
;     240                                 return 44;
	LDI  R30,LOW(44)
	RJMP _0x62
;     241                                 break;
;     242                         default:
_0x22:
;     243                                 return 255;
	LDI  R30,LOW(255)
	RJMP _0x62
;     244                                 break;
;     245                 }
;     246           } 
;     247           
;     248         }       
;     249                 
;     250    }
_0xA:
	SUBI R16,-1
	RJMP _0x8
_0x9:
;     251     
;     252    
;     253    return 255 ;
	LDI  R30,LOW(255)
_0x62:
	CALL __LOADLOCR4
	ADIW R28,8
	RET
;     254         
;     255 }
;     256 
;     257 //////////////////////////////////////////////
;     258 //////////////////////////////////////////////
;     259 
;     260 
;     261 unsigned int get_num(unsigned int min, unsigned int max)
;     262 {           
_get_num:
;     263 unsigned int numb = 0;
;     264 unsigned char _num, _x = 0, _key;
;     265 _num = 0;
	CALL __SAVELOCR5
;	min -> Y+7
;	max -> Y+5
;	numb -> R16,R17
;	_num -> R18
;	_x -> R19
;	_key -> R20
	LDI  R16,0
	LDI  R17,0
	LDI  R19,0
	LDI  R18,LOW(0)
;     266 do    
_0x24:
;     267 {
;     268  lcd_gotoxy(_x, 1);
	CALL SUBOPT_0x4
;     269 _key = scan_key();
	CALL _scan_key
	MOV  R20,R30
;     270 if (_key != 255) 
	CPI  R20,255
	BRNE PC+3
	JMP _0x26
;     271 {
;     272   delay_ms(5);
	CALL SUBOPT_0x2
;     273   _key = scan_key();
	CALL _scan_key
	MOV  R20,R30
;     274   if (_key != 255) 
	CPI  R20,255
	BRNE PC+3
	JMP _0x27
;     275   {
;     276     switch (_key)
	MOV  R30,R20
;     277     {
;     278      case 1  : if (_x < 4) {_num = 1; numb = numb *10; numb += _num; lcd_putsf("1"); _x++; delay_ms(150);} break;
	CPI  R30,LOW(0x1)
	BRNE _0x2B
	CPI  R19,4
	BRSH _0x2C
	LDI  R18,LOW(1)
	CALL SUBOPT_0x5
	__POINTW1FN _0,0
	CALL SUBOPT_0x6
_0x2C:
	RJMP _0x2A
;     279      case 2  : if (_x < 4) {_num = 2; numb = numb *10; numb += _num; lcd_putsf("2"); _x++; delay_ms(150);} break;
_0x2B:
	CPI  R30,LOW(0x2)
	BRNE _0x2D
	CPI  R19,4
	BRSH _0x2E
	LDI  R18,LOW(2)
	CALL SUBOPT_0x5
	__POINTW1FN _0,2
	CALL SUBOPT_0x6
_0x2E:
	RJMP _0x2A
;     280      case 3  : if (_x < 4) {_num = 3; numb = numb *10; numb += _num; lcd_putsf("3"); _x++; delay_ms(150);} break;
_0x2D:
	CPI  R30,LOW(0x3)
	BRNE _0x2F
	CPI  R19,4
	BRSH _0x30
	LDI  R18,LOW(3)
	CALL SUBOPT_0x5
	__POINTW1FN _0,4
	CALL SUBOPT_0x6
_0x30:
	RJMP _0x2A
;     281      case 4  : if (_x < 4) {_num = 4; numb = numb *10; numb += _num; lcd_putsf("4"); _x++; delay_ms(150);} break;
_0x2F:
	CPI  R30,LOW(0x4)
	BRNE _0x31
	CPI  R19,4
	BRSH _0x32
	LDI  R18,LOW(4)
	CALL SUBOPT_0x5
	__POINTW1FN _0,6
	CALL SUBOPT_0x6
_0x32:
	RJMP _0x2A
;     282      case 5  : if (_x < 4) {_num = 5; numb = numb *10; numb += _num; lcd_putsf("5"); _x++; delay_ms(150);} break;
_0x31:
	CPI  R30,LOW(0x5)
	BRNE _0x33
	CPI  R19,4
	BRSH _0x34
	LDI  R18,LOW(5)
	CALL SUBOPT_0x5
	__POINTW1FN _0,8
	CALL SUBOPT_0x6
_0x34:
	RJMP _0x2A
;     283      case 6  : if (_x < 4) {_num = 6; numb = numb *10; numb += _num; lcd_putsf("6"); _x++; delay_ms(150);} break;
_0x33:
	CPI  R30,LOW(0x6)
	BRNE _0x35
	CPI  R19,4
	BRSH _0x36
	LDI  R18,LOW(6)
	CALL SUBOPT_0x5
	__POINTW1FN _0,10
	CALL SUBOPT_0x6
_0x36:
	RJMP _0x2A
;     284      case 7  : if (_x < 4) {_num = 7; numb = numb *10; numb += _num; lcd_putsf("7"); _x++; delay_ms(150);} break;
_0x35:
	CPI  R30,LOW(0x7)
	BRNE _0x37
	CPI  R19,4
	BRSH _0x38
	LDI  R18,LOW(7)
	CALL SUBOPT_0x5
	__POINTW1FN _0,12
	CALL SUBOPT_0x6
_0x38:
	RJMP _0x2A
;     285      case 8  : if (_x < 4) {_num = 8; numb = numb *10; numb += _num; lcd_putsf("8"); _x++; delay_ms(150);} break;
_0x37:
	CPI  R30,LOW(0x8)
	BRNE _0x39
	CPI  R19,4
	BRSH _0x3A
	LDI  R18,LOW(8)
	CALL SUBOPT_0x5
	__POINTW1FN _0,14
	CALL SUBOPT_0x6
_0x3A:
	RJMP _0x2A
;     286      case 9  : if (_x < 4) {_num = 9; numb = numb *10; numb += _num; lcd_putsf("9"); _x++; delay_ms(150);} break;
_0x39:
	CPI  R30,LOW(0x9)
	BRNE _0x3B
	CPI  R19,4
	BRSH _0x3C
	LDI  R18,LOW(9)
	CALL SUBOPT_0x5
	__POINTW1FN _0,16
	CALL SUBOPT_0x6
_0x3C:
	RJMP _0x2A
;     287      case 0  : if (_x < 4) {_num = 0; numb = numb *10; numb += _num; lcd_putsf("0"); _x++; delay_ms(150);} break;
_0x3B:
	CPI  R30,0
	BRNE _0x3D
	CPI  R19,4
	BRSH _0x3E
	LDI  R18,LOW(0)
	CALL SUBOPT_0x5
	__POINTW1FN _0,18
	CALL SUBOPT_0x6
_0x3E:
	RJMP _0x2A
;     288      case 43 : if (_x > 0) {_x--; lcd_gotoxy(_x, 1); lcd_putsf(" "); numb = numb / 10; delay_ms(150);}; break;
_0x3D:
	CPI  R30,LOW(0x2B)
	BRNE _0x3F
	CPI  R19,1
	BRLO _0x40
	SUBI R19,1
	CALL SUBOPT_0x4
	__POINTW1FN _0,20
	CALL SUBOPT_0x7
	MOVW R26,R16
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	MOVW R16,R30
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	CALL SUBOPT_0x3
_0x40:
	RJMP _0x2A
;     289      case 44 : if (numb < min) {numb = min; }; if (numb > max) {numb = max; }; break;
_0x3F:
	CPI  R30,LOW(0x2C)
	BRNE _0x2A
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	CP   R16,R30
	CPC  R17,R31
	BRSH _0x42
	__GETWRS 16,17,7
_0x42:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	CP   R30,R16
	CPC  R31,R17
	BRSH _0x43
	__GETWRS 16,17,5
_0x43:
;     290     }
_0x2A:
;     291     lcd_gotoxy(_x, 1);
	CALL SUBOPT_0x4
;     292   }
;     293 }
_0x27:
;     294 } while(_key != 44);
_0x26:
	CPI  R20,44
	BREQ _0x25
	RJMP _0x24
_0x25:
;     295 //numb = max-min;
;     296 return numb;
	MOVW R30,R16
	CALL __LOADLOCR5
	ADIW R28,9
	RET
;     297 }
;     298 
;     299 void lcd_panel1(void)
;     300 {
_lcd_panel1:
;     301 char s_s[5];
;     302 #asm("cli")               
	SBIW R28,5
;	s_s -> Y+0
	cli
;     303 lcd_clear();
	CALL SUBOPT_0x8
;     304 lcd_gotoxy(0,0);
;     305 lcd_putsf("Freq :      hz. ");
	__POINTW1FN _0,22
	CALL SUBOPT_0x7
;     306 lcd_gotoxy(0, 1);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x9
;     307 lcd_putsf("R :   . Y-G:%   ");
	__POINTW1FN _0,39
	CALL SUBOPT_0x7
;     308 itoa(frequnce, s_s);
	ST   -Y,R8
	ST   -Y,R7
	CALL SUBOPT_0xA
;     309 lcd_gotoxy(7, 0);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
;     310 lcd_puts(s_s);
	CALL SUBOPT_0xB
;     311 itoa(radu, s_s);
	ST   -Y,R10
	ST   -Y,R9
	CALL SUBOPT_0xA
;     312 lcd_gotoxy(3, 1);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x9
;     313 lcd_puts(s_s);
	CALL SUBOPT_0xB
;     314 itoa(scale, s_s);
	MOV  R30,R11
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xA
;     315 lcd_gotoxy(13, 1);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x9
;     316 lcd_puts(s_s);
	CALL SUBOPT_0xB
;     317 #asm("sei")
	sei
;     318 }
	ADIW R28,5
	RET
;     319 
;     320 void panel2(void)           // change freq
;     321 {   
_panel2:
;     322 #asm("cli")               
	cli
;     323 lcd_clear(); 
	CALL SUBOPT_0x8
;     324 lcd_gotoxy(0, 0);
;     325 lcd_putsf("2000 > Freq > 9");
	__POINTW1FN _0,56
	CALL SUBOPT_0x7
;     326 frequnce = get_num(10, 1300);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1300)
	LDI  R31,HIGH(1300)
	CALL SUBOPT_0xC
	__PUTW1R 7,8
;     327 ph1 = 0;
	CALL SUBOPT_0xD
;     328 ph2 = radu * _FF_;
;     329 T1 = ((F1hz / frequnce) - 34)*-1;  
;     330 TCNT1 = T1;
;     331 lcd_panel1();
	CALL _lcd_panel1
;     332 }
	RET
;     333 
;     334 void panel3(void)           // change phase
;     335 {            
_panel3:
;     336 #asm("cli")               
	cli
;     337 lcd_clear();
	CALL SUBOPT_0x8
;     338 lcd_gotoxy(0, 0);
;     339 lcd_putsf("Phase R  (0~359)");
	__POINTW1FN _0,72
	CALL SUBOPT_0x7
;     340 ph1 = 0;
	CLR  R5
;     341 radu = get_num(0, 359);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(359)
	LDI  R31,HIGH(359)
	CALL SUBOPT_0xC
	__PUTW1R 9,10
;     342 ph2 = radu * _FF_;
	__GETW1R 9,10
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x3F360BF6
	CALL __MULF12
	CALL __CFD1
	MOV  R6,R30
;     343 T1 = ((F1hz / frequnce) )*-1;  
	CALL SUBOPT_0xE
	CALL SUBOPT_0xF
;     344 TCNT1 = T1;
	CALL SUBOPT_0x0
;     345 lcd_panel1();
	CALL _lcd_panel1
;     346 }
	RET
;     347 
;     348 void panel4(void)           // change scale
;     349 {            
_panel4:
;     350 #asm("cli")               
	cli
;     351 lcd_clear(); 
	CALL SUBOPT_0x8
;     352 lcd_gotoxy(0, 0);
;     353 lcd_putsf("Scale 1~5 * %20");
	__POINTW1FN _0,89
	CALL SUBOPT_0x7
;     354 Psec = get_num(1, 5) - 1; 
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL SUBOPT_0xC
	SBIW R30,1
	MOV  R4,R30
;     355 switch(Psec)
	MOV  R30,R4
;     356 {
;     357 case 0 : scale = 20; break;
	CPI  R30,0
	BRNE _0x47
	LDI  R30,LOW(20)
	RJMP _0x63
;     358 case 1 : scale = 40; break;
_0x47:
	CPI  R30,LOW(0x1)
	BRNE _0x48
	LDI  R30,LOW(40)
	RJMP _0x63
;     359 case 2 : scale = 60; break;
_0x48:
	CPI  R30,LOW(0x2)
	BRNE _0x49
	LDI  R30,LOW(60)
	RJMP _0x63
;     360 case 3 : scale = 80; break;
_0x49:
	CPI  R30,LOW(0x3)
	BRNE _0x4A
	LDI  R30,LOW(80)
	RJMP _0x63
;     361 case 4 : scale = 100; break;
_0x4A:
	CPI  R30,LOW(0x4)
	BRNE _0x46
	LDI  R30,LOW(100)
_0x63:
	MOV  R11,R30
;     362 }
_0x46:
;     363 ph1 = 0;
	CALL SUBOPT_0xD
;     364 ph2 = radu * _FF_;
;     365 T1 = ((F1hz / frequnce) - 34)*-1;  
;     366 TCNT1 = T1;
;     367 lcd_panel1();
	CALL _lcd_panel1
;     368 }
	RET
;     369 
;     370 
;     371 void main(void)
;     372 {
_main:
;     373 
;     374 unsigned char keybd;
;     375 // Declare your local variables here
;     376 
;     377 // Input/Output Ports initialization
;     378 // Port A initialization
;     379 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
;     380 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
;     381 PORTA=0x00;
;	keybd -> R16
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     382 DDRA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;     383 
;     384 // Port B initialization
;     385 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
;     386 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
;     387 PORTB=0xF0;
	LDI  R30,LOW(240)
	OUT  0x18,R30
;     388 DDRB=0x0F;
	LDI  R30,LOW(15)
	OUT  0x17,R30
;     389 
;     390 // Port C initialization
;     391 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
;     392 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
;     393 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     394 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     395 
;     396 // Port D initialization
;     397 // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
;     398 // State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
;     399 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     400 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     401 
;     402 // Timer/Counter 0 initialization
;     403 // Clock source: System Clock
;     404 // Clock value: Timer 0 Stopped
;     405 // Mode: Normal top=FFh
;     406 // OC0 output: Disconnected
;     407 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     408 TCNT0=0x00;
	OUT  0x32,R30
;     409 OCR0=0x00;
	OUT  0x3C,R30
;     410 
;     411 // Timer/Counter 1 initialization
;     412 // Clock source: System Clock
;     413 // Clock value: 16000.000 kHz
;     414 // Mode: Normal top=FFFFh
;     415 // OC1A output: Discon.
;     416 // OC1B output: Discon.
;     417 // Noise Canceler: Off
;     418 // Input Capture on Falling Edge
;     419 // Timer 1 Overflow Interrupt: On
;     420 // Input Capture Interrupt: Off
;     421 // Compare A Match Interrupt: Off
;     422 // Compare B Match Interrupt: Off
;     423 TCCR1A=0x00;
	OUT  0x2F,R30
;     424 TCCR1B=0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;     425 TCNT1H=0xAA;
	LDI  R30,LOW(170)
	OUT  0x2D,R30
;     426 TCNT1L=0xAA;
	OUT  0x2C,R30
;     427 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
;     428 ICR1L=0x00;
	OUT  0x26,R30
;     429 OCR1AH=0x00;
	OUT  0x2B,R30
;     430 OCR1AL=0x00;
	OUT  0x2A,R30
;     431 OCR1BH=0x00;
	OUT  0x29,R30
;     432 OCR1BL=0x00;
	OUT  0x28,R30
;     433 
;     434 // Timer/Counter 2 initialization
;     435 // Clock source: System Clock
;     436 // Clock value: Timer 2 Stopped
;     437 // Mode: Normal top=FFh
;     438 // OC2 output: Disconnected
;     439 ASSR=0x00;
	OUT  0x22,R30
;     440 TCCR2=0x00;
	OUT  0x25,R30
;     441 TCNT2=0x00;
	OUT  0x24,R30
;     442 OCR2=0x00;
	OUT  0x23,R30
;     443 
;     444 // External Interrupt(s) initialization
;     445 // INT0: Off
;     446 // INT1: Off
;     447 // INT2: Off
;     448 MCUCR=0x00;
	OUT  0x35,R30
;     449 MCUCSR=0x00;
	OUT  0x34,R30
;     450 
;     451 // Timer(s)/Counter(s) Interrupt(s) initialization
;     452 TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
;     453 
;     454 // Analog Comparator initialization
;     455 // Analog Comparator: Off
;     456 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     457 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     458 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     459 
;     460 // LCD module initialization
;     461 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     462 // Global enable interrupts
;     463 frequnce = 100;        
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	__PUTW1R 7,8
;     464 T1 = ((F1hz / frequnce) -33)*-1;
	CALL SUBOPT_0xE
	__SUBD1N 33
	CALL SUBOPT_0xF
;     465 lcd_panel1(); 
	CALL _lcd_panel1
;     466 while (1)
_0x4C:
;     467       {
;     468       // Place your code here
;     469 //      keybd = get_kbd();
;     470 //      if (keybd != 255)
;     471 //      {
;     472 //      delay_ms(5);
;     473       keybd = scan_key();
	CALL _scan_key
	MOV  R16,R30
;     474       if (keybd != 255)
	CPI  R16,255
	BREQ _0x4F
;     475       {
;     476         switch (keybd)
	MOV  R30,R16
;     477         {
;     478            case F1 : panel2(); break;
	CPI  R30,LOW(0xE)
	BRNE _0x53
	CALL _panel2
	RJMP _0x52
;     479            case F2 : panel3(); break;
_0x53:
	CPI  R30,LOW(0x18)
	BRNE _0x54
	CALL _panel3
	RJMP _0x52
;     480            case F3 : panel4(); break;
_0x54:
	CPI  R30,LOW(0x22)
	BRNE _0x52
	CALL _panel4
;     481         }
_0x52:
;     482       }
;     483 //      }
;     484       };
_0x4F:
	RJMP _0x4C
;     485 }
_0x56:
	RJMP _0x56

_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret
__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G3:
	.BYTE 0x4

	.CSEG
__lcd_delay_G3:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G3:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G3:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    andi  r30,0xf0
	RET
_lcd_read_byte0_G3:
	CALL __lcd_delay_G3
	CALL __lcd_read_nibble_G3
    mov   r26,r30
	CALL __lcd_read_nibble_G3
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R12,Y+1
	LDD  R13,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R13,R30
	MOV  R12,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R12
	CP   R14,R12
	BRSH _0x58
	__lcd_putchar1:
	INC  R13
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R13
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x58:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
	ST   -Y,R16
_0x59:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R16,R30
	CPI  R30,0
	BREQ _0x5B
	ST   -Y,R16
	CALL _lcd_putchar
	RJMP _0x59
_0x5B:
	RJMP _0x61
_lcd_putsf:
	ST   -Y,R16
_0x5C:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R16,R30
	CPI  R30,0
	BREQ _0x5E
	ST   -Y,R16
	CALL _lcd_putchar
	RJMP _0x5C
_0x5E:
_0x61:
	LDD  R16,Y+0
	ADIW R28,3
	RET
__long_delay_G3:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G3:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R14,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
	CALL SUBOPT_0x10
	CALL SUBOPT_0x10
	CALL SUBOPT_0x10
	CALL __long_delay_G3
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(40)
	CALL SUBOPT_0x11
	LDI  R30,LOW(4)
	CALL SUBOPT_0x11
	LDI  R30,LOW(133)
	CALL SUBOPT_0x11
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G3
	CPI  R30,LOW(0x5)
	BREQ _0x5F
	LDI  R30,LOW(0)
	RJMP _0x60
_0x5F:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x60:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x0:
	LDS  R30,_T1
	LDS  R31,_T1+1
	LDS  R22,_T1+2
	LDS  R23,_T1+3
	OUT  0x2C+1,R31
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:96 WORDS
SUBOPT_0x5:
	__MULBNWRU 16,17,10
	MOVW R16,R30
	MOV  R30,R18
	LDI  R31,0
	__ADDWRR 16,17,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:60 WORDS
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
	SUBI R19,-1
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x7:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x8:
	CALL _lcd_clear
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	JMP  _itoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _get_num

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0xD:
	CLR  R5
	__GETW1R 9,10
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x3F360BF6
	CALL __MULF12
	CALL __CFD1
	MOV  R6,R30
	__GETW1R 7,8
	__GETD2N 0x1E848
	CLR  R22
	CLR  R23
	CALL __DIVD21
	__SUBD1N 34
	__GETD2N 0xFFFFFFFF
	CALL __MULD12
	STS  _T1,R30
	STS  _T1+1,R31
	STS  _T1+2,R22
	STS  _T1+3,R23
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	__GETW1R 7,8
	__GETD2N 0x1E848
	CLR  R22
	CLR  R23
	CALL __DIVD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xF:
	__GETD2N 0xFFFFFFFF
	CALL __MULD12
	STS  _T1,R30
	STS  _T1+1,R31
	STS  _T1+2,R22
	STS  _T1+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	CALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G3

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R19
	CLR  R20
	LDI  R21,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R19
	ROL  R20
	SUB  R0,R30
	SBC  R1,R31
	SBC  R19,R22
	SBC  R20,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R19,R22
	ADC  R20,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R21
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOV  R24,R19
	MOV  R25,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
