/*****************************************************
Project : Dimmer
Version : 1.0
Date    : 02/01/2008
Author  : hamid badami                             
Company : www.eca.ir                          
web site: www.ha-micro.ir



                           
Chip type               : ATmega8L
Program type            : Application
Clock frequency         : 8.000000 MHz
Memory model            : Small
External SRAM size      : 0
Data Stack size         : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib



char LightIntensity=50;

////////////////////////////////////////////ok
void show_number(char a,char c,char temp) //
{                                         //
unsigned char number[3];                  //
char b;                                   //
for(b=0;b<3;b++)                          //
 {                                        //
 number[b]=temp%10;                       //
 temp/=10;                                //
 _lcd_ready();                            //
 lcd_gotoxy(a+1-b,c);                     //
 lcd_putchar(number[b]|0x30);             //
 }                                        //
}                                         //
////////////////////////////////////////////

/////////////////////////////////////////////////////////ok      
// Timer 1 output compare A interrupt service routine  //
interrupt [7] void timer1_compa_isr(void)     //
        {                                              //
        PORTD.4=0;                                     //
        }                                              //
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////not used
// Timer 1 output compare B interrupt service routine  //
interrupt [8] void timer1_compb_isr(void)     //
        {                                              // 
        }                                              //
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////ok
// Analog Comparator interrupt service routine //
interrupt [17] void ana_comp_isr(void)   //
        {                                      //
        PORTD.4=1;                             //
        TCNT1H=0x00;                           //
        TCNT1L=0x00;                           //
        }                                      //
/////////////////////////////////////////////////

///////////////////////////////////////////
void SetTimers(void)
        {
        OCR1A=((int)(LightIntensity)*100);
        if(LightIntensity>99)
                TCCR1B=0x00;
        else
                TCCR1B=0x02;        
        //OCR1B=((int)(200-LightIntensity)*100);
        }
///////////////////////////////////////////

// Declare your global variables here

void main(void)
{
// Declare your local variables here
//char loop;
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0xff;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x11;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7.813 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: On
TCCR1A=0x00;
TCCR1B=0x02;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
// OCR1AH=0x13;
// OCR1AL=0x88;
// OCR1BH=0x3a;
// OCR1BL=0x98;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x18;

// Analog Comparator initialization
// Analog Comparator: On
// Interrupt on Output Toggle
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x08;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts

PORTD.4=1;
SetTimers();
#asm("sei")
lcd_gotoxy(0,0);
lcd_putsf("Light Intensity");
show_number(1,1,LightIntensity);
while (1)
      {
      while(PINC.5==0)
        {
        if(LightIntensity<100)
                LightIntensity++;
        SetTimers();
        lcd_gotoxy(0,0);
        lcd_putsf("Light Intensity");
        show_number(1,1,LightIntensity);
        delay_ms(500);
        }
      while(PINC.2==0)
        {
        if(LightIntensity>1)
                LightIntensity--;
        SetTimers();
        lcd_gotoxy(0,0);
        lcd_putsf("Light Intensity");
        show_number(1,1,LightIntensity);
        delay_ms(500);
        }

      };
}
