
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega32
;Program type           : Application
;Clock frequency        : 4.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 700 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "sms.vec"
	.INCLUDE "sms.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x31C)
	LDI  R29,HIGH(0x31C)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x31C
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.8d Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : SMS Controller
;       9 Version :
;      10 Date    : 1/1/2002
;      11 Author  : Mohammad
;      12 Company : Griffin
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega32
;      17 Program type        : Application
;      18 Clock frequency     : 4.000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 512
;      22 *****************************************************/
;      23 
;      24 #include <mega32.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;      28 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      32 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <string.h>
;      37 #include <stdio.h>
;      38 #include <stdlib.h>
;      39 #include <delay.h>
;      40 #include <math.h>
;      41 //#include "MtoS.c"
;      42 #include <stdio.h>
;      43 // Alphanumeric LCD Module functions
;      44 #asm
;      45    .equ __lcd_port=0x15 ;PORTC
   .equ __lcd_port=0x15 ;PORTC
;      46 #endasm
;      47 #include <lcd.h>
;      48 
;      49 #define RXB8 1
;      50 #define TXB8 0
;      51 #define UPE 2
;      52 #define OVR 3
;      53 #define FE 4
;      54 #define UDRE 5
;      55 #define RXC 7
;      56 
;      57 #define FRAMING_ERROR (1<<FE)
;      58 #define PARITY_ERROR (1<<UPE)
;      59 #define DATA_OVERRUN (1<<OVR)
;      60 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      61 #define RX_COMPLETE (1<<RXC)
;      62 
;      63 
;      64 #define msg_MAX 350
;      65 
;      66 #define Phone 0
;      67 #define Simcard 1
;      68 
;      69 
;      70 
;      71 unsigned int index=0;
;      72 
;      73 flash char n1[1][13]={"09153174784"};

	.CSEG
;      74 
;      75 
;      76 
;      77 int senderNoLength, messageLength;
;      78 
;      79 unsigned char senderNo[14];

	.DSEG
_senderNo:
	.BYTE 0xE
;      80 unsigned char msg_read_buffer[180]= {0};
_msg_read_buffer:
	.BYTE 0xB4
;      81 
;      82 char des_no_buffer[12]="0912";
_des_no_buffer:
	.BYTE 0xC
;      83 char msg_send_buffer[160]="Salam";
_msg_send_buffer:
	.BYTE 0xA0
;      84 
;      85 
;      86 unsigned char i,j;
;      87 unsigned char state;
;      88 
;      89 // USART Receiver buffer
;      90 #define RX_BUFFER_SIZE 350
;      91 char rx_buffer[RX_BUFFER_SIZE];
_rx_buffer:
	.BYTE 0x15E
;      92 
;      93 #if RX_BUFFER_SIZE<256
;      94 unsigned char rx_wr_index,rx_rd_index,rx_counter;
;      95 #else
;      96 unsigned int rx_wr_index,rx_rd_index,rx_counter;
_rx_wr_index:
	.BYTE 0x2
_rx_rd_index:
	.BYTE 0x2
_rx_counter:
	.BYTE 0x2
;      97 #endif
;      98 
;      99 // This flag is set on USART Receiver buffer overflow
;     100 bit rx_buffer_overflow;
;     101 
;     102 
;     103 
;     104 
;     105 void decode_PDU(unsigned char* input,unsigned int ch_1st);
;     106 unsigned char intvalue(char ch);
;     107 unsigned int find_pdu_st(unsigned char* input);
;     108 void read_msg(unsigned char msg_no);
;     109 void send_msg(void);
;     110 void delet_msg(unsigned char msg_no);
;     111 void msg_memory_set(unsigned char);
;     112 char* encode_PDU(unsigned char* inputMsg);
;     113 char wait_resp(void);
;     114 void recharge(char* input_code);
;     115 unsigned char asciiValue(char);
;     116 
;     117 
;     118 void clear_rx_buffer(void);
;     119 void phone_init(void);
;     120 void micro_init(void);
;     121 
;     122 
;     123 
;     124 /////////////////////////////////////////////////
;     125 /////////////////////////////////////////////////
;     126 
;     127 // USART Receiver interrupt service routine
;     128 interrupt [USART_RXC] void usart_rx_isr(void)
;     129 {

	.CSEG
_usart_rx_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     130 char status,data;
;     131 status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;     132 data=UDR;
	IN   R16,12
;     133 
;     134 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     135    {
;     136    rx_buffer[rx_wr_index]=data;
	LDS  R30,_rx_wr_index
	LDS  R31,_rx_wr_index+1
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
;     137    if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
	LDS  R26,_rx_wr_index
	LDS  R27,_rx_wr_index+1
	ADIW R26,1
	STS  _rx_wr_index,R26
	STS  _rx_wr_index+1,R27
	CPI  R26,LOW(0x15E)
	LDI  R30,HIGH(0x15E)
	CPC  R27,R30
	BRNE _0x4
	LDI  R30,0
	STS  _rx_wr_index,R30
	STS  _rx_wr_index+1,R30
;     138    if (++rx_counter == RX_BUFFER_SIZE)
_0x4:
	LDS  R26,_rx_counter
	LDS  R27,_rx_counter+1
	ADIW R26,1
	STS  _rx_counter,R26
	STS  _rx_counter+1,R27
	CPI  R26,LOW(0x15E)
	LDI  R30,HIGH(0x15E)
	CPC  R27,R30
	BRNE _0x5
;     139       {
;     140       rx_counter=0;
	LDI  R30,0
	STS  _rx_counter,R30
	STS  _rx_counter+1,R30
;     141       rx_buffer_overflow=1;
	SET
	BLD  R2,0
;     142       };
_0x5:
;     143    };
_0x3:
;     144 }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;     145 
;     146 #ifndef _DEBUG_TERMINAL_IO_
;     147 // Get a character from the USART Receiver buffer
;     148 #define _ALTERNATE_GETCHAR_
;     149 #pragma used+
;     150 char getchar(void)
;     151 {
;     152 char data;
;     153 while (rx_counter==0);
;	data -> R17
;     154 data=rx_buffer[rx_rd_index];
;     155 if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
;     156 #asm("cli")
;     157 --rx_counter;
;     158 #asm("sei")
;     159 return data;
;     160 }
;     161 #pragma used-
;     162 #endif
;     163 
;     164 /////////////////////////////////////////////////
;     165 /////////////////////////////////////////////////
;     166 
;     167 
;     168 enum
;     169 {
;     170        State_Ringing,
;     171        State_Calling,
;     172        State_Msg_Received,
;     173        State_Msg_Sending
;     174        //STATE_MENU
;     175 };
;     176 /////////////////////////////////////////////////////////////////////////////////////////////////////////
;     177 void main(void)
;     178 {
_main:
;     179 
;     180 
;     181 
;     182 micro_init();
	RCALL _micro_init
;     183 
;     184 //phone_init();
;     185 //printf("at+csca=\"+9891100500\"\r");
;     186 //delay_ms(1000);
;     187 //send_msg();
;     188 //while(strcmp(ok_str,end_buffer)!=0)
;     189 
;     190 
;     191 //printf("at+cmer=3,0,2,0,0\r");
;     192 
;     193  // VTS
;     194 
;     195 
;     196 //printf("at+cclk=\"07/10/20,10:40:00\"\r");
;     197 //read_date();
;     198 //
;     199 //lear_rx_buffer();
;     200 //printf("AT*ECAM=1\r");
;     201 //while(wait_resp()!=0);
;     202 
;     203 
;     204 
;     205 
;     206 
;     207 
;     208 /*while(wait_resp()!=0);
;     209 printf("at+ckpd=\"1\"\r");
;     210 while(wait_resp()!=0);
;     211 printf("at+ckpd=\"#\"\r");
;     212 while(wait_resp()!=0);
;     213 printf("at+ckpd=\"S\"\r");
;     214   */
;     215   //for(index=0;index<200;index++)
;     216 //         send_msg();
;     217 //clear_rx_buffer();
;     218 //read_msg(1);
;     219 
;     220 //while(wait_resp()!=0);
;     221 //recharge(msg_send_buffer);
;     222         send_msg();
	RCALL _send_msg
;     223 while (1)
_0xA:
;     224       {
;     225 
;     226       };
	RJMP _0xA
;     227 }
_0xD:
	RJMP _0xD
;     228 /////////////////////////////////////////////////////////////////////////////////////////////////////////
;     229 
;     230 /////////////////////////////////////////
;     231 /////////////////////////////////////////
;     232 void delet_msg(unsigned char msg_no)
;     233 {
;     234         char str[2];
;     235         clear_rx_buffer();
;	msg_no -> Y+2
;	str -> Y+0
;     236         itoa(msg_no,str);
;     237         printf("AT+CMGD=%s\r",str);
;     238         while(wait_resp()!=0);
;     239 }
;     240 /////////////////////////////////////////
;     241 /////////////////////////////////////////
;     242 
;     243 void read_msg(unsigned char msg_no)
;     244 {
;     245         char str[2];
;     246         clear_rx_buffer();
;	msg_no -> Y+2
;	str -> Y+0
;     247         itoa(msg_no,str);
;     248         printf("AT+CMGR=%s\r",str);
;     249         while(wait_resp()!=0);
;     250         decode_PDU(rx_buffer,find_pdu_st(rx_buffer));
;     251 
;     252 }
;     253 /////////////////////////////////////////
;     254 /////////////////////////////////////////
;     255 void send_msg()
;     256 {
_send_msg:
;     257         char str[2],encoded_des_no[11],send_buffer[200]="0001000C9189",send_temp[5]="0000";
;     258 
;     259         int i,pdu_len;
;     260         for(i=0;i<11;i++)
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,29
	LDI  R24,205
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x14*2)
	LDI  R31,HIGH(_0x14*2)
	CALL __INITLOCB
	CALL __SAVELOCR4
;	str -> Y+220
;	encoded_des_no -> Y+209
;	send_buffer -> Y+9
;	send_temp -> Y+4
;	i -> R16,R17
;	pdu_len -> R18,R19
	__GETWRN 16,17,0
_0x16:
	__CPWRN 16,17,11
	BRGE _0x17
;     261         {
;     262                 if(fmod(i,2)==0)
	CALL SUBOPT_0x0
	CALL __CPD10
	BRNE _0x18
;     263                 {
;     264                      encoded_des_no[i]=des_no_buffer[i+2];
	MOVW R26,R28
	SUBI R26,LOW(-(209))
	SBCI R27,HIGH(-(209))
	ADD  R26,R16
	ADC  R27,R17
	MOVW R30,R16
	__ADDW1MN _des_no_buffer,2
	LD   R30,Z
	RJMP _0x15C
;     265                 }
;     266                 else if (fmod(i,2)==1)
_0x18:
	CALL SUBOPT_0x0
	__CPD1N 0x3F800000
	BRNE _0x1A
;     267                 {
;     268                         encoded_des_no[i]=des_no_buffer[i];
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(209))
	SBCI R27,HIGH(-(209))
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDI  R26,LOW(_des_no_buffer)
	LDI  R27,HIGH(_des_no_buffer)
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	MOVW R26,R0
_0x15C:
	ST   X,R30
;     269                 }
;     270         }
_0x1A:
	__ADDWRN 16,17,1
	RJMP _0x16
_0x17:
;     271 
;     272         strncat(send_buffer,encoded_des_no,10);
	CALL SUBOPT_0x1
	MOVW R30,R28
	SUBI R30,LOW(-(211))
	SBCI R31,HIGH(-(211))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	CALL _strncat
;     273         strncat(send_buffer,send_temp,4);
	CALL SUBOPT_0x1
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _strncat
;     274         strcat(send_buffer,encode_PDU(msg_send_buffer));
	CALL SUBOPT_0x1
	LDI  R30,LOW(_msg_send_buffer)
	LDI  R31,HIGH(_msg_send_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _encode_PDU
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
;     275         pdu_len=(strlen(send_buffer)-2)/2;
	CALL SUBOPT_0x1
	CALL _strlen
	SBIW R30,2
	LSR  R31
	ROR  R30
	MOVW R18,R30
;     276         while(1)
_0x1B:
;     277         {
;     278         clear_rx_buffer();
	RCALL _clear_rx_buffer
;     279         itoa(pdu_len,str);
	ST   -Y,R19
	ST   -Y,R18
	MOVW R30,R28
	SUBI R30,LOW(-(222))
	SBCI R31,HIGH(-(222))
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
;     280         printf("AT+CMGS=%s\r",str);
	__POINTW1FN _0,35
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(222))
	SBCI R31,HIGH(-(222))
	CALL SUBOPT_0x2
;     281         while(strstrf(rx_buffer,">")==0);
_0x1E:
	CALL SUBOPT_0x3
	__POINTW1FN _0,47
	CALL SUBOPT_0x4
	BREQ _0x1E
;     282 
;     283 
;     284         printf("%s\x1A",send_buffer);
	__POINTW1FN _0,49
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,11
	CALL SUBOPT_0x2
;     285 
;     286         if(wait_resp()==0)
	RCALL _wait_resp
	CPI  R30,0
	BREQ _0x15B
;     287                 return;
;     288 
;     289         }
	RJMP _0x1B
;     290 
;     291 
;     292 }
_0x15B:
	CALL __LOADLOCR4
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,33
	RET
;     293 /////////////////////////////////////////
;     294 /////////////////////////////////////////
;     295 void msg_memory_set(unsigned char memory_unit)
;     296 {
;     297         if(memory_unit==0)
;	memory_unit -> Y+0
;     298                 printf("AT+CPMS=\"ME\"\r");
;     299         else if(memory_unit==1)
;     300                 printf("AT+CPMS=\"SM\"\r");
;     301 
;     302 }
;     303 
;     304 /////////////////////////////////////////
;     305 /////////////////////////////////////////
;     306 void phone_init(void)
;     307 {
;     308 
;     309         clear_rx_buffer();
;     310         do
;     311                 msg_memory_set(Phone);     /// select memory storage
;     312         while(wait_resp()!=0);
;     313 
;     314         clear_rx_buffer();
;     315         do
;     316                 printf("AT+CNMI=3,1,2,0\r");   ////enable msg reporting
;     317         while(wait_resp()!=0);
;     318 
;     319         clear_rx_buffer();
;     320         do
;     321                 printf("AT*ESIL=1\r");      /// enable silent mode
;     322         while(wait_resp()!=0);
;     323 
;     324         clear_rx_buffer();
;     325         do
;     326                 printf("AT*ECAM=1\r");      /// enable call monitoring
;     327         while(wait_resp()!=0);
;     328 
;     329 }
;     330 /////////////////////////////////////////
;     331 /////////////////////////////////////////
;     332 
;     333 /////////////////////////////////////////
;     334 /////////////////////////////////////////
;     335 
;     336 char wait_resp(void)
;     337 {
_wait_resp:
;     338         while(1)
_0x31:
;     339         {
;     340 
;     341                 if (strstrf(rx_buffer,"OK")!=0)
	CALL SUBOPT_0x3
	__POINTW1FN _0,120
	CALL SUBOPT_0x4
	BREQ _0x34
;     342                         return 0;
	LDI  R30,LOW(0)
	RET
;     343                 else  if (strstrf(rx_buffer,"ERROR")!=0)
_0x34:
	CALL SUBOPT_0x3
	__POINTW1FN _0,123
	CALL SUBOPT_0x4
	BREQ _0x36
;     344                         return 1;
	LDI  R30,LOW(1)
	RET
;     345 
;     346         };
_0x36:
	RJMP _0x31
;     347         return 1;
;     348 
;     349 }
;     350 /////////////////////////////////////////
;     351 /////////////////////////////////////////
;     352 void clear_rx_buffer(void)
;     353 {
_clear_rx_buffer:
;     354         int i;
;     355         for(i=0;i<RX_BUFFER_SIZE+1;i++)
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,0
_0x38:
	__CPWRN 16,17,351
	BRGE _0x39
;     356                 rx_buffer[i]=0;
	LDI  R26,LOW(_rx_buffer)
	LDI  R27,HIGH(_rx_buffer)
	ADD  R26,R16
	ADC  R27,R17
	LDI  R30,LOW(0)
	ST   X,R30
;     357         rx_wr_index=0;
	__ADDWRN 16,17,1
	RJMP _0x38
_0x39:
	LDI  R30,0
	STS  _rx_wr_index,R30
	STS  _rx_wr_index+1,R30
;     358 
;     359 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;     360 /////////////////////////////////////////
;     361 /////////////////////////////////////////
;     362 
;     363 void recharge(char* input_code)
;     364 {
;     365         clear_rx_buffer();
;	*input_code -> Y+0
;     366         printf("AT+CKPD=\"ee*140*%s#s\"\r",input_code);
;     367         while(wait_resp()!=0);
;     368 }
;     369 /////////////////////////////////////////
;     370 /////////////////////////////////////////
;     371 char* encode_PDU(unsigned char* inputMsg)
;     372 {
_encode_PDU:
;     373      int i=0,j=0;
;     374     char encodedMsg [100];
;     375     char stringEncodedMsg [200];
;     376     unsigned char bitsToTransfer = 0x7F,shiftCount = 6,nextVal;
;     377     nextVal=inputMsg[0];
	SBIW R28,45
	SUBI R29,1
	CALL __SAVELOCR6
;	*inputMsg -> Y+307
;	i -> R16,R17
;	j -> R18,R19
;	encodedMsg -> Y+207
;	stringEncodedMsg -> Y+7
;	bitsToTransfer -> R21
;	shiftCount -> R20
;	nextVal -> Y+6
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	LDI  R20,6
	LDI  R21,127
	CALL SUBOPT_0x5
	LD   R30,X
	STD  Y+6,R30
;     378     while ((inputMsg[i] > 0))
_0x3D:
	MOVW R30,R16
	CALL SUBOPT_0x6
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH PC+3
	JMP _0x3F
;     379     {
;     380 
;     381         bitsToTransfer = bitsToTransfer >> shiftCount;
	MOV  R30,R20
	MOV  R26,R21
	CALL __LSRB12
	MOV  R21,R30
;     382         bitsToTransfer = bitsToTransfer &  inputMsg[i+1];
	CALL SUBOPT_0x7
	LD   R30,X
	AND  R21,R30
;     383         bitsToTransfer = bitsToTransfer << (shiftCount+1);
	MOV  R30,R20
	SUBI R30,-LOW(1)
	MOV  R26,R21
	CALL __LSLB12
	MOV  R21,R30
;     384         encodedMsg [ j++ ] = nextVal | bitsToTransfer;
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(207))
	SBCI R27,HIGH(-(207))
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R21
	LDD  R26,Y+6
	OR   R30,R26
	MOVW R26,R0
	ST   X,R30
;     385         nextVal =  inputMsg [ i+1 ] >> (7 - shiftCount);
	CALL SUBOPT_0x7
	LD   R26,X
	LDI  R30,LOW(7)
	SUB  R30,R20
	CALL __LSRB12
	STD  Y+6,R30
;     386         shiftCount--;
	SUBI R20,1
;     387         i++;
	__ADDWRN 16,17,1
;     388         bitsToTransfer = 0xFF;
	LDI  R21,LOW(255)
;     389         if( ((i % 8) == 7) && (inputMsg[i+1]>0))
	MOVW R26,R16
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL __MODW21
	SBIW R30,7
	BRNE _0x41
	CALL SUBOPT_0x7
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH _0x42
_0x41:
	RJMP _0x40
_0x42:
;     390         {
;     391             shiftCount = 6;
	LDI  R20,LOW(6)
;     392             i++;
	__ADDWRN 16,17,1
;     393             nextVal=inputMsg[i];
	MOVW R30,R16
	CALL SUBOPT_0x6
	LD   R30,X
	STD  Y+6,R30
;     394         }
;     395     }
_0x40:
	RJMP _0x3D
_0x3F:
;     396     stringEncodedMsg[1]=asciiValue(i%16);
	MOVW R26,R16
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CALL __MODW21
	ST   -Y,R30
	RCALL _asciiValue
	STD  Y+8,R30
;     397     if (i<16)
	__CPWRN 16,17,16
	BRGE _0x43
;     398         stringEncodedMsg[0]=48;
	LDI  R30,LOW(48)
	RJMP _0x15D
;     399     else
_0x43:
;     400         stringEncodedMsg[0]=asciiValue(i/16);
	MOVW R26,R16
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CALL __DIVW21
	ST   -Y,R30
	RCALL _asciiValue
_0x15D:
	STD  Y+7,R30
;     401     for( i=1; i < j+1; i++)
	__GETWRN 16,17,1
_0x46:
	MOVW R30,R18
	ADIW R30,1
	CP   R16,R30
	CPC  R17,R31
	BRLT PC+3
	JMP _0x47
;     402     {
;     403         stringEncodedMsg [ 2*i ] = encodedMsg [ i-1 ] & 0xF0;
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
	ANDI R30,LOW(0xF0)
	MOVW R26,R0
	CALL SUBOPT_0xA
;     404         stringEncodedMsg [ 2*i ] = stringEncodedMsg [ 2*i ] >> 4;
	MOVW R22,R30
	CALL SUBOPT_0xB
	MOVW R0,R30
	MOVW R30,R22
	CALL SUBOPT_0xC
	LD   R30,X
	SWAP R30
	ANDI R30,0xF
	MOVW R26,R0
	ST   X,R30
;     405         stringEncodedMsg [ 2*i ] &= 0x0F;
	CALL SUBOPT_0x8
	MOVW R26,R30
	LD   R30,X
	ANDI R30,LOW(0xF)
	CALL SUBOPT_0xA
;     406         stringEncodedMsg [ 2*i ] = asciiValue(stringEncodedMsg [ 2*i ]);
	MOVW R0,R30
	CALL SUBOPT_0xB
	PUSH R31
	PUSH R30
	MOVW R30,R0
	CALL SUBOPT_0xC
	LD   R30,X
	ST   -Y,R30
	RCALL _asciiValue
	POP  R26
	POP  R27
	CALL SUBOPT_0xA
;     407         stringEncodedMsg [ 2*i+1 ] = encodedMsg [ i-1 ] & 0x0F;
	ADIW R30,1
	CALL SUBOPT_0xB
	CALL SUBOPT_0x9
	ANDI R30,LOW(0xF)
	MOVW R26,R0
	CALL SUBOPT_0xA
;     408         stringEncodedMsg [ 2*i+1 ] = asciiValue(stringEncodedMsg [ 2*i+1 ]);
	ADIW R30,1
	MOVW R0,R30
	CALL SUBOPT_0xB
	PUSH R31
	PUSH R30
	MOVW R30,R0
	CALL SUBOPT_0xC
	LD   R30,X
	ST   -Y,R30
	RCALL _asciiValue
	POP  R26
	POP  R27
	ST   X,R30
;     409     }
	__ADDWRN 16,17,1
	RJMP _0x46
_0x47:
;     410 
;     411 
;     412 
;     413     return  stringEncodedMsg;
	MOVW R30,R28
	ADIW R30,7
;     414 
;     415 
;     416     return  stringEncodedMsg;
_0x15A:
	CALL __LOADLOCR6
	ADIW R28,53
	SUBI R29,-1
	RET
;     417 
;     418 }
;     419 
;     420 //////////////////////////////////
;     421 //////////////////////////////////
;     422 
;     423 unsigned char asciiValue(char ch)
;     424 {
_asciiValue:
;     425     switch (ch)
;	ch -> Y+0
	LD   R30,Y
;     426     {
;     427     case 0:
	CPI  R30,0
	BRNE _0x4B
;     428         return 48;
	LDI  R30,LOW(48)
	RJMP _0x159
;     429     case 1:
_0x4B:
	CPI  R30,LOW(0x1)
	BRNE _0x4C
;     430         return 49;
	LDI  R30,LOW(49)
	RJMP _0x159
;     431     case 2:
_0x4C:
	CPI  R30,LOW(0x2)
	BRNE _0x4D
;     432         return 50;
	LDI  R30,LOW(50)
	RJMP _0x159
;     433     case 3:
_0x4D:
	CPI  R30,LOW(0x3)
	BRNE _0x4E
;     434         return 51;
	LDI  R30,LOW(51)
	RJMP _0x159
;     435     case 4:
_0x4E:
	CPI  R30,LOW(0x4)
	BRNE _0x4F
;     436         return 52;
	LDI  R30,LOW(52)
	RJMP _0x159
;     437     case 5:
_0x4F:
	CPI  R30,LOW(0x5)
	BRNE _0x50
;     438         return 53;
	LDI  R30,LOW(53)
	RJMP _0x159
;     439     case 6:
_0x50:
	CPI  R30,LOW(0x6)
	BRNE _0x51
;     440         return 54;
	LDI  R30,LOW(54)
	RJMP _0x159
;     441     case 7:
_0x51:
	CPI  R30,LOW(0x7)
	BRNE _0x52
;     442         return 55;
	LDI  R30,LOW(55)
	RJMP _0x159
;     443     case 8:
_0x52:
	CPI  R30,LOW(0x8)
	BRNE _0x53
;     444         return 56;
	LDI  R30,LOW(56)
	RJMP _0x159
;     445     case 9:
_0x53:
	CPI  R30,LOW(0x9)
	BRNE _0x54
;     446         return 57;
	LDI  R30,LOW(57)
	RJMP _0x159
;     447     case 10:
_0x54:
	CPI  R30,LOW(0xA)
	BRNE _0x55
;     448         return 65;
	LDI  R30,LOW(65)
	RJMP _0x159
;     449     case 11:
_0x55:
	CPI  R30,LOW(0xB)
	BRNE _0x56
;     450         return 66;
	LDI  R30,LOW(66)
	RJMP _0x159
;     451     case 12:
_0x56:
	CPI  R30,LOW(0xC)
	BRNE _0x57
;     452         return 67;
	LDI  R30,LOW(67)
	RJMP _0x159
;     453     case 13:
_0x57:
	CPI  R30,LOW(0xD)
	BRNE _0x58
;     454         return 68;
	LDI  R30,LOW(68)
	RJMP _0x159
;     455     case 14:
_0x58:
	CPI  R30,LOW(0xE)
	BRNE _0x59
;     456         return 69;
	LDI  R30,LOW(69)
	RJMP _0x159
;     457     case 15:
_0x59:
	CPI  R30,LOW(0xF)
	BRNE _0x5B
;     458         return 70;
	LDI  R30,LOW(70)
	RJMP _0x159
;     459     default:
_0x5B:
;     460         break;
;     461     }
;     462     return -1;
	LDI  R30,LOW(255)
_0x159:
	ADIW R28,1
	RET
;     463 }
;     464 
;     465 /////////////////////////
;     466 /////////////////////////
;     467 void decode_PDU(unsigned char* input,unsigned int pdu_start)
;     468 {
;     469 	int useless ,septetBtytesNo,RemainBytesNo,charMessageLength;
;     470 	int i,j;
;     471 	unsigned char lastValue;
;     472 	unsigned char tempMsg[180]= {0};
;     473 	unsigned char dateTime[14];
;     474 
;     475 	useless=2+pdu_start;
;	*input -> Y+209
;	pdu_start -> Y+207
;	useless -> R16,R17
;	septetBtytesNo -> R18,R19
;	RemainBytesNo -> R20,R21
;	charMessageLength -> Y+205
;	i -> Y+203
;	j -> Y+201
;	lastValue -> Y+200
;	tempMsg -> Y+20
;	dateTime -> Y+6
;     476 
;     477 	useless += (((int)intvalue(input[0+pdu_start])*10 + intvalue(input[1+pdu_start]))*2);
;     478 	useless +=2;
;     479 	senderNoLength = ((int) intvalue(input[useless])*10 + intvalue(input[useless+1])) ;
;     480 	if(senderNoLength == 12 )
;     481 	{
;     482 	        useless+=6;
;     483 	        senderNo[0]='0';
;     484 	        senderNoLength-=2;
;     485 	}
;     486 	else useless+=4;
;     487 	for(i = 0; i <= senderNoLength-2; i+=2)
;     488 	{
;     489 		senderNo[i+2] = intvalue(input[useless+i])+48;
;     490 		senderNo[i+1] = intvalue(input[useless+i+1])+48;
;     491 	}
;     492 	if((senderNoLength%2)== 1)
;     493 	{
;     494 		senderNo[i] = intvalue(input[useless+i+1])+48;
;     495 		useless += senderNoLength + 1 + 4;
;     496 	}
;     497 	else
;     498 		useless += senderNoLength + 4;
;     499 
;     500 	for(i = 0; i < 12; i+=2)
;     501 	{
;     502 		dateTime[i+1] = intvalue(input[useless+i])+48;
;     503 		dateTime[i] = intvalue(input[useless+i+1])+48;
;     504 	}
;     505 	//timeZone = (((int)dateTime[12]*10) + dateTime[13]);
;     506 	useless += 14;
;     507 	messageLength = ((int) intvalue(input[useless])*10 + intvalue(input[useless+1])) ;
;     508 	charMessageLength = (messageLength - (messageLength/7))*2;
;     509 	useless += 2;
;     510 	for (i=0, j=0; i < charMessageLength; i+=2, j++)
;     511 	{
;     512 		tempMsg[j] = intvalue(input[useless +i]);
;     513 		tempMsg[j] = (tempMsg[j] << 4);
;     514 		tempMsg[j] = (tempMsg [j] | intvalue(input[useless+i+1]));
;     515 	}
;     516 	septetBtytesNo = messageLength / 7;
;     517 	RemainBytesNo = (messageLength % 7) - (messageLength/7);
;     518 	for (i= 0; i < septetBtytesNo; i++)
;     519 	{
;     520 		lastValue = 0x00;
;     521 		for( j= 6; j >= 0; j--)
;     522 		{
;     523 			msg_read_buffer[(i*8)+j+1] = (((tempMsg[(i*7) +  j]) >> (7 - j)) | lastValue) ;
;     524 			lastValue = 0xFF;
;     525 			lastValue = lastValue >> (j+1);
;     526 			lastValue = lastValue & tempMsg[(i*7) + j];
;     527 			lastValue = lastValue << (j);
;     528 		}
;     529 		msg_read_buffer[(i*8)] = (tempMsg[(i*7)] & 0x7F);
;     530 	}
;     531 	j = RemainBytesNo -1;
;     532 	lastValue = 0xFF;
;     533 	lastValue = lastValue >> (j+1);
;     534 	lastValue = lastValue & tempMsg[(septetBtytesNo*7) + j];
;     535 	lastValue = lastValue << (j);
;     536 	for( j = RemainBytesNo -1-1 ; j >= 0; j--)
;     537 	{
;     538 		msg_read_buffer[(septetBtytesNo*8)+j+1] = (((tempMsg[(septetBtytesNo*7) +  j]) >> (7 - j)) | lastValue) ;
;     539 		lastValue = 0xFF;
;     540 		lastValue = lastValue >> (j+1);
;     541 		lastValue = lastValue & tempMsg[(septetBtytesNo*7) + j];
;     542 		lastValue = lastValue << (j);
;     543 	}
;     544 	msg_read_buffer[(septetBtytesNo*8)] = (tempMsg[(septetBtytesNo*7)] & 0x7F);
;     545 
;     546 }
;     547 //////////////////////////////////
;     548 //////////////////////////////////
;     549 unsigned char intvalue(char ch)
;     550 {
;     551 	switch (ch)
;	ch -> Y+0
;     552 	{
;     553 	case 48:
;     554 		return 0;
;     555 	case 49:
;     556 		return 1;
;     557 	case 50:
;     558 		 return 2;
;     559 	case 51:
;     560 		return 3;
;     561 	case 52:
;     562 		return 4;
;     563 	case 53:
;     564 		return 5;
;     565 	case 54:
;     566 		return 6;
;     567 	case 55:
;     568 		return 7;
;     569 	case 56:
;     570 		return 8;
;     571 	case 57:
;     572 		return 9;
;     573 	case 65:
;     574 		return 10;
;     575 	case 66:
;     576 		return 11;
;     577 	case 67:
;     578 		return 12;
;     579 	case 68:
;     580 		return 13;
;     581 	case 69:
;     582 		return 14;
;     583 	case 70:
;     584 		return 15;
;     585 	default:
;     586 		break;
;     587 	}
;     588 	return -1;
;     589 }
;     590 
;     591 
;     592 /////////////////////////////////////////
;     593 /////////////////////////////////////////
;     594 unsigned int find_pdu_st(unsigned char* input)
;     595 {
;     596         unsigned i,j=0;
;     597         for(i=0;i<msg_MAX;i++)
;	*input -> Y+4
;	i -> R16,R17
;	j -> R18,R19
;     598         {
;     599                 if(input[i]==13)
;     600                 {
;     601                         if (j==2)
;     602                         {
;     603                                 return i+2;
;     604                                 break;
;     605                         }
;     606                                 j++;
;     607                 }
;     608 
;     609         }
;     610 }
;     611 /////////////////////////////////////////
;     612 /////////////////////////////////////////
;     613 
;     614 void micro_init(void)
;     615 {
_micro_init:
;     616 // Input/Output Ports initialization
;     617 // Port A initialization
;     618 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     619 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     620 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     621 DDRA=0x00;
	OUT  0x1A,R30
;     622 
;     623 // Port B initialization
;     624 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     625 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     626 PORTB=0x00;
	OUT  0x18,R30
;     627 DDRB=0x00;
	OUT  0x17,R30
;     628 
;     629 // Port C initialization
;     630 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     631 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     632 PORTC=0x00;
	OUT  0x15,R30
;     633 DDRC=0x00;
	OUT  0x14,R30
;     634 
;     635 // Port D initialization
;     636 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     637 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     638 PORTD=0x00;
	OUT  0x12,R30
;     639 DDRD=0x00;
	OUT  0x11,R30
;     640 
;     641 
;     642 // Timer/Counter 0 initialization
;     643 // Clock source: System Clock
;     644 // Clock value: Timer 0 Stopped
;     645 // Mode: Normal top=FFh
;     646 // OC0 output: Disconnected
;     647 TCCR0=0x00;
	OUT  0x33,R30
;     648 TCNT0=0x00;
	OUT  0x32,R30
;     649 OCR0=0x00;
	OUT  0x3C,R30
;     650 
;     651 // Timer/Counter 1 initialization
;     652 // Clock source: System Clock
;     653 // Clock value: Timer 1 Stopped
;     654 // Mode: Normal top=FFFFh
;     655 // OC1A output: Discon.
;     656 // OC1B output: Discon.
;     657 // Noise Canceler: Off
;     658 // Input Capture on Falling Edge
;     659 // Timer 1 Overflow Interrupt: Off
;     660 // Input Capture Interrupt: Off
;     661 // Compare A Match Interrupt: Off
;     662 // Compare B Match Interrupt: Off
;     663 TCCR1A=0x00;
	OUT  0x2F,R30
;     664 TCCR1B=0x00;
	OUT  0x2E,R30
;     665 TCNT1H=0x00;
	OUT  0x2D,R30
;     666 TCNT1L=0x00;
	OUT  0x2C,R30
;     667 ICR1H=0x00;
	OUT  0x27,R30
;     668 ICR1L=0x00;
	OUT  0x26,R30
;     669 OCR1AH=0x00;
	OUT  0x2B,R30
;     670 OCR1AL=0x00;
	OUT  0x2A,R30
;     671 OCR1BH=0x00;
	OUT  0x29,R30
;     672 OCR1BL=0x00;
	OUT  0x28,R30
;     673 
;     674 // Timer/Counter 2 initialization
;     675 // Clock source: System Clock
;     676 // Clock value: Timer 2 Stopped
;     677 // Mode: Normal top=FFh
;     678 // OC2 output: Disconnected
;     679 ASSR=0x00;
	OUT  0x22,R30
;     680 TCCR2=0x00;
	OUT  0x25,R30
;     681 TCNT2=0x00;
	OUT  0x24,R30
;     682 OCR2=0x00;
	OUT  0x23,R30
;     683 
;     684 // External Interrupt(s) initialization
;     685 // INT0: Off
;     686 // INT1: Off
;     687 // INT2: Off
;     688 MCUCR=0x00;
	OUT  0x35,R30
;     689 MCUCSR=0x00;
	OUT  0x34,R30
;     690 
;     691 // Timer(s)/Counter(s) Interrupt(s) initialization
;     692 TIMSK=0x00;
	OUT  0x39,R30
;     693 
;     694 // USART initialization
;     695 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     696 // USART Receiver: On
;     697 // USART Transmitter: On
;     698 // USART Mode: Asynchronous
;     699 // USART Baud rate: 9600
;     700 UCSRA=0x00;
	OUT  0xB,R30
;     701 UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     702 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     703 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     704 UBRRL=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
;     705 
;     706 // Analog Comparator initialization
;     707 // Analog Comparator: Off
;     708 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     709 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     710 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     711 
;     712 // LCD module initialization
;     713 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     714 
;     715 // Global enable interrupts
;     716 #asm("sei")
	sei
;     717 }
	RET

_strcat:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcat0:
    ld   r22,x+
    tst  r22
    brne strcat0
    sbiw r26,1
strcat1:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcat1
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
_strncat:
    ld   r23,y+
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strncat0:
    ld   r22,x+
    tst  r22
    brne strncat0
    sbiw r26,1
strncat1:
    st   x,r23
    tst  r23
    breq strncat2
    dec  r23
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strncat1
strncat2:
    movw r30,r24
    ret
_strstrf:
    ldd  r26,y+2
    ldd  r27,y+3
    movw r24,r26
strstrf0:
    ld   r30,y
    ldd  r31,y+1
strstrf1:
    lpm  r0,z+
    tst  r0
    brne strstrf2
    movw r30,r24
    rjmp strstrf3
strstrf2:
    ld   r22,x+
    cp   r22,r0
    breq strstrf1
    adiw r24,1
    movw r26,r24
    tst  r22
    brne strstrf0
    clr  r30
    clr  r31
strstrf3:
	ADIW R28,4
	RET

	.DSEG
_p_S35:
	.BYTE 0x2

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x9E
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0xA0
	__CPWRN 16,17,2
	BRLO _0xA1
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0xA0:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0xA1:
	RJMP _0xA2
_0x9E:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0xA2:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G3:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0xA3:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0xA5
	MOV  R30,R17
	CPI  R30,0
	BRNE _0xA9
	CPI  R18,37
	BRNE _0xAA
	LDI  R17,LOW(1)
	RJMP _0xAB
_0xAA:
	CALL SUBOPT_0xD
_0xAB:
	RJMP _0xA8
_0xA9:
	CPI  R30,LOW(0x1)
	BRNE _0xAC
	CPI  R18,37
	BRNE _0xAD
	CALL SUBOPT_0xD
	RJMP _0x15E
_0xAD:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0xAE
	LDI  R16,LOW(1)
	RJMP _0xA8
_0xAE:
	CPI  R18,43
	BRNE _0xAF
	LDI  R20,LOW(43)
	RJMP _0xA8
_0xAF:
	CPI  R18,32
	BRNE _0xB0
	LDI  R20,LOW(32)
	RJMP _0xA8
_0xB0:
	RJMP _0xB1
_0xAC:
	CPI  R30,LOW(0x2)
	BRNE _0xB2
_0xB1:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0xB3
	ORI  R16,LOW(128)
	RJMP _0xA8
_0xB3:
	RJMP _0xB4
_0xB2:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0xA8
_0xB4:
	CPI  R18,48
	BRLO _0xB7
	CPI  R18,58
	BRLO _0xB8
_0xB7:
	RJMP _0xB6
_0xB8:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0xA8
_0xB6:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0xBC
	CALL SUBOPT_0xE
	LD   R30,X
	CALL SUBOPT_0xF
	RJMP _0xBD
_0xBC:
	CPI  R30,LOW(0x73)
	BRNE _0xBF
	CALL SUBOPT_0xE
	CALL SUBOPT_0x10
	CALL _strlen
	MOV  R17,R30
	RJMP _0xC0
_0xBF:
	CPI  R30,LOW(0x70)
	BRNE _0xC2
	CALL SUBOPT_0xE
	CALL SUBOPT_0x10
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0xC0:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0xC3
_0xC2:
	CPI  R30,LOW(0x64)
	BREQ _0xC6
	CPI  R30,LOW(0x69)
	BRNE _0xC7
_0xC6:
	ORI  R16,LOW(4)
	RJMP _0xC8
_0xC7:
	CPI  R30,LOW(0x75)
	BRNE _0xC9
_0xC8:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0xCA
_0xC9:
	CPI  R30,LOW(0x58)
	BRNE _0xCC
	ORI  R16,LOW(8)
	RJMP _0xCD
_0xCC:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0xFE
_0xCD:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0xCA:
	SBRS R16,2
	RJMP _0xCF
	CALL SUBOPT_0xE
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xD0
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0xD0:
	CPI  R20,0
	BREQ _0xD1
	SUBI R17,-LOW(1)
	RJMP _0xD2
_0xD1:
	ANDI R16,LOW(251)
_0xD2:
	RJMP _0xD3
_0xCF:
	CALL SUBOPT_0xE
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0xD3:
_0xC3:
	SBRC R16,0
	RJMP _0xD4
_0xD5:
	CP   R17,R21
	BRSH _0xD7
	SBRS R16,7
	RJMP _0xD8
	SBRS R16,2
	RJMP _0xD9
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0xDA
_0xD9:
	LDI  R18,LOW(48)
_0xDA:
	RJMP _0xDB
_0xD8:
	LDI  R18,LOW(32)
_0xDB:
	CALL SUBOPT_0xD
	SUBI R21,LOW(1)
	RJMP _0xD5
_0xD7:
_0xD4:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0xDC
_0xDD:
	CPI  R19,0
	BREQ _0xDF
	SBRS R16,3
	RJMP _0xE0
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x15F
_0xE0:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x15F:
	ST   -Y,R30
	CALL SUBOPT_0x11
	CPI  R21,0
	BREQ _0xE2
	SUBI R21,LOW(1)
_0xE2:
	SUBI R19,LOW(1)
	RJMP _0xDD
_0xDF:
	RJMP _0xE3
_0xDC:
_0xE5:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0xE7:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0xE9
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0xE7
_0xE9:
	CPI  R18,58
	BRLO _0xEA
	SBRS R16,3
	RJMP _0xEB
	SUBI R18,-LOW(7)
	RJMP _0xEC
_0xEB:
	SUBI R18,-LOW(39)
_0xEC:
_0xEA:
	SBRC R16,4
	RJMP _0xEE
	CPI  R18,49
	BRSH _0xF0
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0xEF
_0xF0:
	RJMP _0x160
_0xEF:
	CP   R21,R19
	BRLO _0xF4
	SBRS R16,0
	RJMP _0xF5
_0xF4:
	RJMP _0xF3
_0xF5:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0xF6
	LDI  R18,LOW(48)
_0x160:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0xF7
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x11
	CPI  R21,0
	BREQ _0xF8
	SUBI R21,LOW(1)
_0xF8:
_0xF7:
_0xF6:
_0xEE:
	CALL SUBOPT_0xD
	CPI  R21,0
	BREQ _0xF9
	SUBI R21,LOW(1)
_0xF9:
_0xF3:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0xE6
	RJMP _0xE5
_0xE6:
_0xE3:
	SBRS R16,0
	RJMP _0xFA
_0xFB:
	CPI  R21,0
	BREQ _0xFD
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0xF
	RJMP _0xFB
_0xFD:
_0xFA:
_0xFE:
_0xBD:
_0x15E:
	LDI  R17,LOW(0)
_0xA8:
	RJMP _0xA3
_0xA5:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G3
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret
_fmod:
	SBIW R28,4
	__GETD1S 4
	CALL __CPD10
	BRNE _0x14A
	__GETD1N 0x0
	RJMP _0x158
_0x14A:
	__GETD1S 4
	__GETD2S 8
	CALL __DIVF21
	__PUTD1S 0
	CALL SUBOPT_0x12
	CALL __CPD10
	BRNE _0x14B
	__GETD1N 0x0
	RJMP _0x158
_0x14B:
	__GETD2S 0
	CALL __CPD02
	BRGE _0x14C
	CALL SUBOPT_0x12
	CALL __PUTPARD1
	CALL _floor
	RJMP _0x161
_0x14C:
	CALL SUBOPT_0x12
	CALL __PUTPARD1
	CALL _ceil
_0x161:
	__PUTD1S 0
	CALL SUBOPT_0x12
	__GETD2S 4
	CALL __MULF12
	__GETD2S 8
	CALL __SWAPD12
	CALL __SUBF12
_0x158:
	ADIW R28,12
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G6:
	.BYTE 0x4
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_delay_G6:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	CALL __lcd_delay_G6
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G6
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G6:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G6
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G6
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G6
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G6:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G6
    andi  r30,0xf0
	RET
_lcd_read_byte0_G6:
	CALL __lcd_delay_G6
	CALL __lcd_read_nibble_G6
    mov   r26,r30
	CALL __lcd_read_nibble_G6
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	MOV  R12,R30
	RET
__long_delay_G6:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G6:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G6
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G6,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G6,3
	CALL SUBOPT_0x13
	CALL SUBOPT_0x13
	CALL SUBOPT_0x13
	CALL __long_delay_G6
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G6
	CALL __long_delay_G6
	LDI  R30,LOW(40)
	CALL SUBOPT_0x14
	LDI  R30,LOW(4)
	CALL SUBOPT_0x14
	LDI  R30,LOW(133)
	CALL SUBOPT_0x14
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G6
	CPI  R30,LOW(0x5)
	BREQ _0x156
	LDI  R30,LOW(0)
	RJMP _0x157
_0x156:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x157:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	MOVW R30,R16
	CALL __CWD1
	CALL __CDF1
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	JMP  _fmod

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(_rx_buffer)
	LDI  R31,HIGH(_rx_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	CALL _strstrf
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x5:
	__GETW2SX 307
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x5
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	MOVW R30,R16
	ADIW R30,1
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	MOVW R30,R16
	LSL  R30
	ROL  R31
	MOVW R26,R28
	ADIW R26,7
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x9:
	MOVW R0,R30
	MOVW R30,R16
	SBIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(207))
	SBCI R27,HIGH(-(207))
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	ST   X,R30
	MOVW R30,R16
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	MOVW R26,R28
	ADIW R26,7
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	MOVW R26,R28
	ADIW R26,7
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0xD:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xE:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x11:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x12:
	__GETD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	CALL __long_delay_G6
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G6

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x14:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G6

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

	rjmp __addfc

_ceil:
	rcall __ftrunc
	brne __ceil1
__ceil0:
	ret
__ceil1:
	brts __ceil0
	ldi  r25,0x3f

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSRB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSRB12R
__LSRB12L:
	LSR  R30
	DEC  R0
	BRNE __LSRB12L
__LSRB12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
